var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_fs = require("fs");
var import_path = require("path");

// src/utils/index.ts
var commentRegEx = new RegExp(/^#/);
var isComment = /* @__PURE__ */ __name((line) => commentRegEx.test(line), "isComment");
var startWithExport = /* @__PURE__ */ __name((line) => new RegExp(/^export/i).test(line), "startWithExport");
var isValidVariableName = /* @__PURE__ */ __name((variable) => new RegExp(/[a-zA-Z_]+[a-zA-Z0-9_]*/).test(variable), "isValidVariableName");

// src/index.ts
var loadEnvTypes = /* @__PURE__ */ __name((rootPath, options) => {
  if (!rootPath) {
    rootPath = process.cwd();
  }
  const fileName = (options == null ? void 0 : options.filename) ? options == null ? void 0 : options.filename : ".env";
  let envPath = (0, import_path.join)(rootPath, fileName);
  console.log(` *** loading environment variables from ${envPath}.`);
  let outputFileName = (options == null ? void 0 : options.outputPath) ? (0, import_path.join)(options == null ? void 0 : options.outputPath, "env.d.ts") : (0, import_path.join)(rootPath, "env.d.ts");
  const data = (0, import_fs.readFileSync)(envPath, {
    encoding: "utf8"
  }).replace(/("""|''').*?\1/g, "").trim();
  let variables = [];
  for (const line of data.split(/\n/)) {
    if (!isComment(line)) {
      if (startWithExport(line)) {
        if (line.trim().length !== 0) {
          const _var = line.split(/=/)[0].trim().split(/\s/)[1];
          if (isValidVariableName(_var)) {
            variables.push(_var);
          } else {
            throw new Error(`There's an invalid variable name in your ${fileName} file.`);
          }
        }
      } else {
        if (line.indexOf("=") === -1 && line.trim().length !== 0) {
          throw new Error(`Invalid syntax in your ${fileName} file.`);
        } else {
          if (line.trim().length !== 0) {
            const _var = line.split(/=/)[0].trim();
            if (isValidVariableName(_var)) {
              variables.push(_var);
            } else {
              throw new Error(`There's an invalid variable name in your ${fileName} file.`);
            }
          }
        }
      }
    }
  }
  variables = variables.filter((v) => v.length >= 1);
  variables = [
    ...new Set(variables)
  ];
  const outPutText = `
  // types for your environmental variables
  declare namespace NodeJS {
    export interface ProcessEnv {
      ${variables.map((v, i) => {
    if (i === 0) {
      return v + " : string;\n";
    } else {
      return "			" + v + " : string;\n";
    }
  })}
    }
  }
  `.replace(/,/gim, "");
  (0, import_fs.writeFileSync)(outputFileName, outPutText);
  console.log(`
 *** created env-types at ${outputFileName}.
`);
}, "loadEnvTypes");
var src_default = loadEnvTypes;
